
var fgDebug = false;
var fgGlobalDoc = null;

var messages = srGetStrBundle("chrome://foxgame/locale/foxgame.properties");

function addJavaScript(doc, js) {
    
  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.setAttribute("src", js);
  head.appendChild(script);
  
  return script;
    
}

function addFiring(doc, func) {

  var head = doc.getElementsByTagName("head")[0];    

  var script = doc.createElement("script");
  script.setAttribute("language", "JavaScript");
  script.innerHTML = 'function fire(){'+
	'window.removeEventListener("mousemove", fire, true);'+
	func+'();'+
	'}'+
	'window.addEventListener("mousemove", fire, true);';
  head.appendChild(script);


}

function fgEvalnode(path,document,node) {
	var ret = document.evaluate(path,node,null,
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	if (fgDebug) alert(ret.snapshotLength);

	return ret;

}

function fgEval(path,document) {
	return fgEvalnode(path,document,document);
}

function isOGameDomain(href) {

    if (href.match(/^file:\/\//) && fgDebug) return true;
          
     var sites = new Array(/^http:\/\/ogame\d*\.de/i,
				/^http:\/\/.*\.ogamed*\.de\.es/i,
				/^http:\/\/(.*\.)?ogame\.com\.es/i,
				/^http:\/\/(.*\.)?ogame\.de/i,
				/^http:\/\/(.*\.)?ogame\.fr/i,
				/^http:\/\/(.*\.)?ogame\.pl/i,
				/^http:\/\/(.*\.)?ogame\.org/i);
            
     for (var i = 0; i< sites.length; i++) {
        if (href.search(sites[i]) > -1) {
          return true;   
        } 
     }    
     return false;
}

function adjustPagesfg(event)	{
    
       var doc = event.originalTarget;
       
       try {
           if (doc.nodeType != doc.DOCUMENT_NODE) 
                doc = doc.ownerDocument;
		
		fgGlobalDoc = doc;
		var href = doc.location.href;     
		if (isOGameDomain(href)) {
			var functions = new Array(
				selectUniverse,
				addFlotaTime,
				addFlotaReturnTime,
				addMilosButtons,
				addKeyNavigation,
				removePlanets,
				//addPlanetTooltips,
				colorizePrivates,
				replicateDeleteOptions
				//addDebrisImage
			);
			callOgameFunctions(functions, doc);
		}
	} catch (e) {
		foxgameDebug(e);
	}

}

function callOgameFunction(func, doc) {
    try {
        func(doc);   
    } catch (e) {
        foxgamedebug(e);
    }
}

function callOgameFunctions(funcs, doc) {
    
    for (var i=0; i<funcs.length; i++) {
        callOgameFunction(funcs[i], doc);
    }
    
}

function foxgame_initPopupMenu(event) {
    try {    
    	if (event.target.id != "contentAreaContextMenu") return;

    	var fgMenu = document.getElementById("foxgame-config-menu");
	dump(isOGameDomain(window._content.document.location.href)+"\n");
	fgMenu.setAttribute("hidden",!isOGameDomain(window._content.document.location.href));
//	fgMenu.setAttribute("collapsed",!isOGameDomain(window._content.document.location.href));
//	fgMenu.hidden = !isOGameDomain(window._content.document.location.href);
//	fgMenu.collapsed = !isOGameDomain(window._content.document.location.href);
	dump(fgMenu.hidden+"\n");
	return;
    } catch (e){
        foxgamedebug(e);
    }

}

function foxgamedebug(text) {
   alert(text);
   dump(text + "\n");
}

function isLoginUrl(href) {
    return href.search(/portal\//i) > -1;
}

function isFlota2Url(href) {
	return href.search(/flotten2\.php/i) > -1;
}

function isFlotaUrl(href) {
	return href.search(/flotten1\.php/i) > -1;
}

function isGalaxyUrl(href) {
	return href.search(/galaxy\.php/i) > -1;
}

function isMessagesUrl(href) {
	return href.search(/\/messages\.php/i) > -1;
}

function selectUniverse(doc) {

	if (doc && !isLoginUrl(doc.location.href)) return;
	if (!fgGetBooleanPref("foxgameSelectUniverse",true)) return;

	try {
		if (doc.location.href.indexOf(PrefsBranchFG.getCharPref("fgServer")) == -1) return;
	} catch(e){ return;}

	if (fgDebug) alert("Estamos Universo");

	try {
		var uni = PrefsBranchFG.getCharPref("fgUni");
	} catch(e) { return;}
	var univeroption = doc.evaluate( 
		'//option[@value="'+uni+'"]', doc, null, 					
		XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
	univeroption.snapshotItem(0).selected = true;
}

function addKeyNavigation(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameKeyNavigation",true)) return;

	
	if (fgDebug) alert("Estamos teclado");

	//Insertamos el .js con la funcion de navegacion por teclado

	addJavaScript(document, "chrome://foxgame/content/resources/js/keyGalaxy.js");

}

function addDebrisImage(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	
	if (fgDebug) alert("Estamos escombros");

	try {
		var as = document.evaluate( 
			'//a[starts-with(@title,"Escombros")]', document, null, 			
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

		var title, metal, cristal;
		for (var i = 0; i < as.snapshotLength; i++) {
			title = as.snapshotItem(i).getAttribute("title");
			title = title.split(' ');
			title = title[1].split(',');
			metal = title[0].split(':');
			metal = metal[1].replace(/\./i,'');
			cristal = title[1].split(':');
			cristal = cristal[1].replace(/\./i,'');
			if (parseInt(metal) + parseInt(cristal) >= 20000) {
				as.snapshotItem(i).innerHTML = 
				'<img src="chrome://foxgame/content/resources/images/economy.jpg" border="0">';
			}	
		}
	} catch (e) {
		foxgamedebug(e);
	}
}

function removePlanets(document) {
	
	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameRemovePlanets",true)) return;
	
	if (fgDebug) alert("Estamos planets");
	

	try {
	      var path = '//table[@width="569"]/child::tbody/child::tr/child::th[position()=2]';
      	var obj = fgEval(path,document);		
	
		if (obj.snapshotLength == 0) return;

		var text;
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (obj.snapshotItem(i).firstChild.nextSibling != null) {
				text = obj.snapshotItem(i).nextSibling.nextSibling.innerHTML;			
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = "";
				obj.snapshotItem(i).nextSibling.nextSibling.appendChild(
					obj.snapshotItem(i).removeChild(obj.snapshotItem(i).firstChild.nextSibling));
				obj.snapshotItem(i).nextSibling.nextSibling.firstChild.innerHTML = text;
			}
			
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=2]';
      	obj = fgEval(path,document);		
		
		for (var i = 0; i < obj.snapshotLength; i++) {
			if (i == 0) {
				text = obj.snapshotItem(i).innerHTML;
				obj.snapshotItem(i).nextSibling.nextSibling.innerHTML = text;
			}
			obj.snapshotItem(i).parentNode.removeChild(obj.snapshotItem(i));
		}

	      path = '//table[@width="569"]/descendant::td[@class="c"][position()=5]';
      	obj = fgEval(path,document);
		obj.snapshotItem(0).innerHTML = messages.GetStringFromName("foxgame.inner.reducedDebris");
		

	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="8"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","7");
		}
	      path = '//table[@width="569"]/descendant::td[@class="c"][@colspan="6"]';
		obj = fgEval(path,document);
		for (var i = 0; i < obj.snapshotLength; i++) {
			obj.snapshotItem(i).setAttribute("colspan","5");
		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function colorizePrivates(document) {

	if (document && !isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameColorizePrivates",true)) return;

	
	if (fgDebug) alert("Estamos privados");
	
	try {

		var path = '//table/tbody/tr/th[4]/child::a/img[@alt!=""]';
		var obj = fgEval(path,document);
		try {
			var color = PrefsBranchFG.getCharPref("fgPrivateColor");
		} catch(e) { var color ="#AA3333";}

		for (var i = 0; i < obj.snapshotLength; i++)
		{		
			obj2 = obj.snapshotItem(i).parentNode.parentNode.parentNode;
			var nodes = obj2.childNodes;			
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}
			nodes = obj2.nextSibling.nextSibling.childNodes;
			for (var j = 0; j < nodes.length; j++) {
				if (nodes[j].nodeName != "#text")
					nodes[j].setAttribute("style", "background-color : "+color+";");
			}

		}

	} catch (e) {
		foxgamedebug(e);
	}
}

function replicateDeleteOptions(document) {

	if (document && !isMessagesUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameReplicateDeleteOptions",true)) return;

	
	if (fgDebug) alert("Estamos opciones de borrado");
	
	try {
		var path = '//table/tbody/tr/th/select[@name="deletemessages"]';
		var row = fgEval(path,document);
		if (row.snapshotLength == 0) return;
		row = row.snapshotItem(0).parentNode.parentNode;
		var row2 = row.cloneNode(true);
		row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages");
		row.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages2').options[this.selectedIndex].selected='true'");

		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("name","deletemessages2");
		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("id","deletemessages2");
		row2.firstChild.nextSibling.firstChild.nextSibling.setAttribute("onchange","document.getElementById('deletemessages').options[this.selectedIndex].selected='true'");
		row.parentNode.insertBefore(row2,row.parentNode.firstChild);
		
		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//input[@name="messages"]', document)
		if (table.snapshotLength == 0) return;
		table = table.snapshotItem(0).parentNode.parentNode.parentNode.parentNode;
		var form = fgEval (
			'//form[starts-with(@action,"messages")]', document).snapshotItem(0);
		if (form.snapshotLength == 0) return;
		form = form.parentNode.removeChild(form);

		table.parentNode.replaceChild(form,table);
		form.appendChild(table);

	} catch (e) {
		foxgamedebug(e);
	}
}

String.prototype.trim = function() {

 // skip leading and trailing whitespace
 // and return everything in between
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}

String.prototype.retrim = function() {

 // skip leading and trailing whitespace
 // and return everything in between
  var x=this;
  x=x.replace(/^\s*(.*)/, "$1");
  x=x.replace(/(.*)\s*(.*)/g, "$1 $2");
  x=x.replace(/(.*?)\s*$/, "$1");
  return x;
}

function addMilosButtons(document) {

	if (document && !isGalaxyUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameAddMilosButtons",false)) return;

	
	if (fgDebug) alert("Estamos milos");
	
	try {
//Insertamos el .js con la funcion de envio del formulario

		addJavaScript(document, "chrome://foxgame/content/resources/js/milosGalaxy.js");


// Generamos un formulario para enviar la galaxia a MILOS directamente

      var path = '//table[@width="569"]';
      var obj = fgEval(path,document);

	if (obj.snapshotLength == 0) return;

	obj = obj.snapshotItem(0);
	var tr = obj.firstChild.nextSibling.firstChild;
	var text = "";
      var range = document.createRange();

	while (tr != null)
 	{
		if (tr.nodeName == 'TR') {
			td = tr.firstChild;
			while (td != null) {
				if (td.nodeName == 'TD' || td.nodeName == 'TH')
				{
						var a = fgEvalnode('.//img[contains(@alt,"M")]',document,td);
						if (a.snapshotLength > 0) 
						{
							text += "M \t";
						}
						else {
						      range.selectNode(td);
							text += range.toString().retrim()+" \t";
						}
				}
				td = td.nextSibling;
			}
			text = text.substr(0,text.length-2)+"\n";
		}
		tr = tr.nextSibling;
	}
	range.detach;
	texto = text;


		//Insertamos un formulario para poder enviar los datos directamente.	

		var form = document.createElement('tr');
		var td = document.createElement('td');
		td.setAttribute("colspan","8");
		td.setAttribute("class","1");
		td.setAttribute("align","center");
		td.setAttribute("valign","middle");
		td.innerHTML = 
		"<div style=\"position:absolute; z-index:1; top:100px; left:50px; visibility: hidden\" id=\"div_frame\">"+
		'<table celspacing="0" celpadding="0"><tr><td align="right"><a onclick="hide()">Cerrar</a></td></tr><tr><td>'+
		"<iframe src=\"\" name=\"_milos\"id=\"_milos\" height=\"300\" width=\"600\"></iframe>"+
		'</td></tr></table></div>'+
		'<form action="http://milos.nethen.org/milos-paste/#" method=post target="_milos" id="milos_form">'+
		'<input type=hidden name="show" value="">'+
		'<input type=hidden name="noncommit" value="">'+
		'<input type=hidden name="delafter" value="checked">'+
		'<input type=hidden name=x value="'+texto+'">'+
		//'<textarea name=x rows=1 cols=75>'+texto+'</textarea>'+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos&prev")+"\" onClick=\"next('l')\">"+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos")+"\" onClick=\"next('1')\">"+
		"<input type=button value=\""+messages.GetStringFromName("foxgame.inner.milos&next")+"\" onClick=\"next('r')\">";
		
		form.appendChild(td);

		var tds = fgEval( 
			'//table[@width="569"]/descendant::td[@colspan="2"][@class="c"][last()]', document).snapshotItem(0);
		tds.parentNode.parentNode.appendChild(form);
	

	} catch (e) {
		foxgamedebug(e);
	}
}

function addFlotaReturnTime(document) {

	if (document && !isFlotaUrl(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaReturnTime",true)) return;

	
	if (fgDebug) alert("Estamos flota return");

	try {
		//Aadimos la hora de retorno en caso de retirada
		var date2 = new Date();
		var obj = fgEval( '//input[@name="order_return"]', document);
		for ( var i = 0; i < obj.snapshotLength; i++) {
			var date = new Date();
			var cell = obj.snapshotItem(i).parentNode.parentNode;
			var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
			startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date.getYear()),"E MMM d H:m:s y");
			date.setTime(date.getTime() + date.getTime() - startTime);
			var font = document.createElement('font');
			font.setAttribute('color','lime');
			var div = document.createElement('div');
			div.setAttribute('id',"time_"+i);
			if (date.getDay() != date2.getDay())
				div.innerHTML = formatDate(date,"d/MM H:mm:ss");
			else
				div.innerHTML = formatDate(date,"H:mm:ss");	
			font.appendChild(div);
			cell.appendChild(font);
		}
		if (obj.snapshotLength > 0)
			setTimeout(fgadjustReturnTime,499);
	} catch (e) {
		foxgamedebug(e);
	}
};

function fgadjustReturnTime(){
		try {
			var document = fgGlobalDoc;
			if (document && document.location && !isFlotaUrl(document.location.href)) return;
			var i=0;
			var obj;
			var date2 = new Date();
			obj = document.getElementById("time_"+i);
			while (obj != null) {
				var date = new Date();
				var cell = obj.parentNode.parentNode;
				var startTime = cell.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling.previousSibling;
				startTime = getDateFromFormat(startTime.innerHTML + " " + (1900+date.getYear()),"E MMM d H:m:s y");
				date.setTime(date.getTime() + date.getTime() - startTime);
				if (date.getDay() != date2.getDay())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");			
				i++;
				obj = document.getElementById("time_"+i);
			}
			setTimeout(fgadjustReturnTime, 499);
		} catch (e) {
			foxgamedebug(e);
		}
}

function fgDuration(document) {
	try {
	  	var speedfactor;

		speedfactor = document.getElementsByName("speedfactor")[0].value;
		var msp = fgMaxspeed(document);
		var sp = document.getElementsByName("speed")[0].value;
		var dist = fgDistance(document);

  		return Math.round(((35000 / sp * Math.sqrt(dist * 10 / msp) + 10) / speedfactor)); 
	} catch(e) {
		setTimeout(fgadjustTime, 100);
	}
}


function min(a, b) {
  a = a * 1;
  b = b * 1;
  if (a > b) {
    return b;
  } else {
    return a;
  }
}

function fgMaxspeed(document) {
	try {
		var msp = 1000000000;
		for (i = 200; i < 220; i++) {
			if (document.getElementsByName("ship" + i)[0]) {
				if ((document.getElementsByName("speed" + i)[0].value * 1) >= 1
				&& (document.getElementsByName("ship" + i)[0].value * 1) >= 1) {
					msp = min(msp, document.getElementsByName("speed" + i)[0].value);
				}
			}
		}
		return(msp);
	} catch(e) {
		setTimeout(fgadjustTime, 100);
	}
}

function fgDistance(document) {
	try {
  		var thisGalaxy;
  		var thisSystem;
  		var thisPlanet;

  		var targetGalaxy;
  		var targetSystem;
  		var targetPlanet;

  		var dist;

  		thisGalaxy = document.getElementsByName("thisgalaxy")[0].value;
  		thisSystem = document.getElementsByName("thissystem")[0].value;
  		thisPlanet = document.getElementsByName("thisplanet")[0].value;

  		targetGalaxy = document.getElementsByName("galaxy")[0].value;
  		targetSystem = document.getElementsByName("system")[0].value;
  		targetPlanet = document.getElementsByName("planet")[0].value;

  		dist = 0;
  		if ((targetGalaxy - thisGalaxy) != 0) {
  			dist = Math.abs(targetGalaxy - thisGalaxy) * 20000;
  		} else if ((targetSystem - thisSystem) != 0) {
    			dist = Math.abs(targetSystem - thisSystem) * 5 * 19 + 2700;
  		} else if ((targetPlanet - thisPlanet) != 0) {
    			dist = Math.abs(targetPlanet - thisPlanet) * 5 + 1000;
  		} else { 
    			dist = 5;
  		}

  		return(dist);
	} catch(e) {
		setTimeout(fgadjustTime, 100);
	}
}


function fgadjustTime(){
		try {
			var document = fgGlobalDoc;
			if (document && document.location && !isFlota2Url(document.location.href)) return;
			var date = new Date();
			var date2 = new Date();
			obj = document.getElementById("llegada1");
			if (obj != null) 
			{
				var duration = fgDuration(document);
				date.setTime(date.getTime() + (duration*1000))
				if (date.getDay() != date2.getDay())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
				date.setTime(date.getTime() + (duration*1000))
			}			
			obj = document.getElementById("llegada2");
			if (obj != null) 
			{	
				if (date.getDay() != date2.getDay())
					obj.innerHTML = formatDate(date,"d/MM H:mm:ss");
				else
					obj.innerHTML = formatDate(date,"H:mm:ss");	
			}			
			setTimeout(fgadjustTime, 500);
		} catch (e) {
			foxgamedebug(e);
		}
}

function addFlotaTime(document) {

	if (document && !isFlota2Url(document.location.href)) return;
	if (!fgGetBooleanPref("foxgameFlotaTime",true)) return;

	
	if (fgDebug) alert("Estamos");

	try {


		// Mostramos la hora de retorno y llegada de las naves

		//Insertamos las filas necesarias en la tabla

		var node = document.getElementById("duration");

		if (node == null) return;

		node = node.parentNode.parentNode;
		var tr2 = document.createElement('tr');
		tr2.setAttribute("height","20");
		var th2 = new Array(document.createElement('th'),document.createElement('th'));
		th2[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival2");
		th2[1].innerHTML = "<div id=\"llegada2\">-</div>";

		for (var i=0; i<th2.length; i++)
			tr2.appendChild(th2[i]);

		node.parentNode.insertBefore(tr2,node.nextSibling);
		var tr = document.createElement('tr');
		tr.setAttribute("height","20");
		var th = new Array(document.createElement('th'),document.createElement('th'));
		th[0].innerHTML = messages.GetStringFromName("foxgame.inner.arrival1");
		th[1].innerHTML = "<div id=\"llegada1\">-</div>";
	
		for (var i=0; i<th.length; i++)
			tr.appendChild(th[i]);

		node.parentNode.insertBefore(tr,node.nextSibling);
	

		//Recolocamos el formulario para que el arbol tenga una estructura correcta
	
		var table = fgEval( 
			'//table[@border="0"][@cellpadding="0"][@cellspacing="1"][@width="519"]', document).snapshotItem(0);
		var form = table.firstChild.nextSibling;
		form = table.removeChild(form);

		var input = fgEval( 
			'//input[@name="thisgalaxy"]', document).snapshotItem(0);
		var center = input.parentNode;
		center.parentNode.replaceChild(form,center);
		form.appendChild(center);

		//Llamamos a la funcion que actualiza el tiempo
		fgadjustTime();
	} catch (e) {
		foxgamedebug(e);
	}
}

window.addEventListener('DOMContentLoaded', adjustPagesfg, true);
window.addEventListener("popupshowing", foxgame_initPopupMenu, false);